summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 6b32884)
raw | patch | inline | side by side (parent: 6b32884)
author | Junio C Hamano <junkio@cox.net> | |
Sat, 22 Oct 2005 11:45:15 +0000 (04:45 -0700) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Sat, 22 Oct 2005 11:45:15 +0000 (04:45 -0700) |
Martin Langhoff wants to use git-merge from outside git-pull and wants
to do further processing; for this, he wants git-merge no to commit
even when it cleanly merges. I think other script writers would want
something like that as well, so here it is.
Instead of the "merge commit message" parameter (which usually is made
for you by "git-pull" which calls this command), you pass an empty
string to it. Then it will not update your HEAD -- you can do whatever
you want with the resulting index file, which contains the merge results.
Signed-off-by: Junio C Hamano <junkio@cox.net>
to do further processing; for this, he wants git-merge no to commit
even when it cleanly merges. I think other script writers would want
something like that as well, so here it is.
Instead of the "merge commit message" parameter (which usually is made
for you by "git-pull" which calls this command), you pass an empty
string to it. Then it will not update your HEAD -- you can do whatever
you want with the resulting index file, which contains the merge results.
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-merge.sh | patch | blob | history |
diff --git a/git-merge.sh b/git-merge.sh
index 3465041bc4c9b2512623ee6c06317ecb7689e528..3457a96cfd7a27ae4dffcf5d3f1ff2f9568bd83d 100755 (executable)
--- a/git-merge.sh
+++ b/git-merge.sh
fi
}
-summary() {
+finish () {
+ test '' = "$2" || echo "$2"
+ case "$merge_msg" in
+ '')
+ echo "No merge message -- not updating HEAD"
+ ;;
+ *)
+ git-update-ref HEAD "$1" "$head" || exit 1
+ ;;
+ esac
+
case "$no_summary" in
'')
- git-diff-tree -p -M $head "$1" |
+ git-diff-tree -p -M "$head" "$1" |
git-apply --stat --summary
;;
esac
1,"$1")
# If head can reach all the merge then we are up to date.
# but first the most common case of merging one remote
- echo "Already up-to-date. Yeeah!"
+ echo "Already up-to-date."
dropsave
exit 0
;;
# Again the most common case of merging one remote.
echo "Updating from $head to $1."
git-update-index --refresh 2>/dev/null
- git-read-tree -u -m $head "$1" &&
new_head=$(git-rev-parse --verify "$1^0") &&
- git-update-ref HEAD "$new_head" "$head" || exit 1
- summary "$1"
+ git-read-tree -u -m $head "$new_head" &&
+ finish "$new_head" "Fast forward"
dropsave
exit 0
;;
echo "$merge_msg" |
git-commit-tree $result_tree -p HEAD -p "$1"
) || exit
- git-update-ref HEAD $result_commit $head
- summary $result_commit
+ finish "$result_commit" "In-index merge"
dropsave
exit 0
fi
parents="$parents -p $remote"
done
result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
- echo "Committed merge $result_commit, made by $wt_strategy."
- git-update-ref HEAD $result_commit $head
- summary $result_commit
+ finish "$result_commit" "Merge $result_commit, made by $wt_strategy."
dropsave
exit 0
fi